/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TInputTypeparam.TInputTypeparamPath;
import de.ship.db.tables.records.TInputParamRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TInputParam extends TableImpl<TInputParamRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_input_param</code>
     */
    public static final TInputParam T_INPUT_PARAM = new TInputParam();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TInputParamRecord> getRecordType() {
        return TInputParamRecord.class;
    }

    /**
     * The column <code>common_dd.t_input_param.lastchange</code>.
     */
    public final TableField<TInputParamRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_input_param.pk</code>.
     */
    public final TableField<TInputParamRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_input_param.fk_input_typeparam</code>.
     */
    public final TableField<TInputParamRecord, Integer> FK_INPUT_TYPEPARAM = createField(DSL.name("fk_input_typeparam"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_input_param.fk_variable</code>.
     */
    public final TableField<TInputParamRecord, Integer> FK_VARIABLE = createField(DSL.name("fk_variable"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_input_param.param</code>. value of this
     * param for this variable
     */
    public final TableField<TInputParamRecord, String> PARAM = createField(DSL.name("param"), SQLDataType.CLOB.nullable(false), this, "value of this param for this variable");

    private TInputParam(Name alias, Table<TInputParamRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TInputParam(Name alias, Table<TInputParamRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_input_param</code> table reference
     */
    public TInputParam(String alias) {
        this(DSL.name(alias), T_INPUT_PARAM);
    }

    /**
     * Create an aliased <code>common_dd.t_input_param</code> table reference
     */
    public TInputParam(Name alias) {
        this(alias, T_INPUT_PARAM);
    }

    /**
     * Create a <code>common_dd.t_input_param</code> table reference
     */
    public TInputParam() {
        this(DSL.name("t_input_param"), null);
    }

    public <O extends Record> TInputParam(Table<O> path, ForeignKey<O, TInputParamRecord> childPath, InverseForeignKey<O, TInputParamRecord> parentPath) {
        super(path, childPath, parentPath, T_INPUT_PARAM);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TInputParamPath extends TInputParam implements Path<TInputParamRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TInputParamPath(Table<O> path, ForeignKey<O, TInputParamRecord> childPath, InverseForeignKey<O, TInputParamRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TInputParamPath(Name alias, Table<TInputParamRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TInputParamPath as(String alias) {
            return new TInputParamPath(DSL.name(alias), this);
        }

        @Override
        public TInputParamPath as(Name alias) {
            return new TInputParamPath(alias, this);
        }

        @Override
        public TInputParamPath as(Table<?> alias) {
            return new TInputParamPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TInputParamRecord, Integer> getIdentity() {
        return (Identity<TInputParamRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TInputParamRecord> getPrimaryKey() {
        return Keys.PK_INPUT_PARAM;
    }

    @Override
    public List<UniqueKey<TInputParamRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_INPUT_PARAM);
    }

    @Override
    public List<ForeignKey<TInputParamRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_INPUT_PARAM__FK_INPUTPARAM_TYPEPARAM, Keys.T_INPUT_PARAM__FK_INPUTPARAM_VARIABLE);
    }

    private transient TInputTypeparamPath _tInputTypeparam;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_input_typeparam</code> table.
     */
    public TInputTypeparamPath tInputTypeparam() {
        if (_tInputTypeparam == null)
            _tInputTypeparam = new TInputTypeparamPath(this, Keys.T_INPUT_PARAM__FK_INPUTPARAM_TYPEPARAM, null);

        return _tInputTypeparam;
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_INPUT_PARAM__FK_INPUTPARAM_VARIABLE, null);

        return _tCoreElementHierarchy;
    }

    @Override
    public TInputParam as(String alias) {
        return new TInputParam(DSL.name(alias), this);
    }

    @Override
    public TInputParam as(Name alias) {
        return new TInputParam(alias, this);
    }

    @Override
    public TInputParam as(Table<?> alias) {
        return new TInputParam(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputParam rename(String name) {
        return new TInputParam(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputParam rename(Name name) {
        return new TInputParam(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputParam rename(Table<?> name) {
        return new TInputParam(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputParam where(Condition condition) {
        return new TInputParam(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputParam where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputParam where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputParam where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputParam where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputParam where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputParam where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputParam where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputParam whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputParam whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
